﻿namespace WorkForFiles
{
    internal class Program
    {
        const string PathFileData = "CompetitionData.txt"; //Константа с названием файла, в котором 
        //хранятся исходные данные соревнований
        const string PathFileResults = "Results.txt"; //Константа с названием файла, в который будут записаны результаты
        static List<Sportsman> sportsmans = new List<Sportsman>(); //Лист спортсменов

        static void Main(string[] args)
        {
            using (StreamReader sr = new StreamReader(PathFileData))
            {
                string strFile = sr.ReadLine(); //Считываем строку из файла
                while (strFile != null)
                {
                    Sportsman tempSportsman = new Sportsman();
                    tempSportsman.name = strFile.Substring(0, strFile.IndexOf(':'));
                    strFile = sr.ReadLine();

                    string[] listTemp = new string[6];
                    listTemp = strFile.Split(' ').ToArray();

                    tempSportsman.sumN = Convert.ToInt32(listTemp[0]) + Convert.ToInt32(listTemp[2]) + Convert.ToInt32(listTemp[4]);
                    int m1 = Convert.ToInt32(listTemp[1].Substring(0, listTemp[1].IndexOf(':')));
                    int s1 = Convert.ToInt32(listTemp[1].Substring(listTemp[1].IndexOf(':') + 1));
                    int m2 = Convert.ToInt32(listTemp[3].Substring(0, listTemp[3].IndexOf(':')));
                    int s2 = Convert.ToInt32(listTemp[3].Substring(listTemp[3].IndexOf(':')+ 1));
                    int m3 = Convert.ToInt32(listTemp[5].Substring(0, listTemp[5].IndexOf(':')));
                    int s3 = Convert.ToInt32(listTemp[5].Substring(listTemp[5].IndexOf(':') + 1));
                    tempSportsman.sumS = s1 + s2 + s3 + (m1 + m2 + m3) * 60;

                    sportsmans.Add(tempSportsman);
                    strFile = sr.ReadLine();
                }
            };
            Podschet();
            WriteInFile();
        }

        /// <summary>
        /// Сортировка листа спортсменов и присваивание мест
        /// </summary>
        static void Podschet()
        {
            sportsmans = sportsmans
                .OrderBy(it => it.sumS)
                .OrderByDescending(it => it.sumN)
                .ToList();
            int count = 1;
            for (int i = 0; i < sportsmans.Count; i++)
            {
                sportsmans[i].place = count;
                if(i < sportsmans.Count - 1)
                {
                    if (sportsmans[i].sumS == sportsmans[i + 1].sumS 
                        && sportsmans[i].sumN == sportsmans[i + 1].sumN)
                    {
                        continue;
                    }   
                }
                count++;
            }
        }

        /// <summary>
        /// Запись результатов соревнований в файл
        /// </summary>
        static void WriteInFile()
        {
            using (StreamWriter sw = new StreamWriter(PathFileResults, false))
            {
                for (int i = 0; i < sportsmans.Count; i++) 
                {
                    sw.WriteLine(sportsmans[i].WriteSportsman);
                }
            };
        }
    }
}
